(* file: print_util.sml *)
(* description: utility functions for printing *)
(* author: Takahito Aoto *)

signature PRINT_UTIL = 
sig 
    val print: string -> unit
    val println: string -> unit
    val hint: string -> unit
    val hintln: string -> unit
    val runDebug: bool ref
    val runSilent: bool ref
    val outs: TextIO.outstream ref
end

structure PrintUtil : PRINT_UTIL =
struct 

(*
Control.Print.printLength := 500;
Control.Print.printDepth  := 500;
Control.Print.stringDepth := 500;
*)

val runDebug = ref false
val runSilent = ref false

val outs = ref TextIO.stdOut

fun print str = if not (!runSilent) andalso (!runDebug) then TextIO.output (!outs,str) else ()
fun println str = if not (!runSilent) andalso (!runDebug) then TextIO.output (!outs,str ^ "\n") else ()

fun hint mesg = if (!runSilent) then () else TextIO.output (!outs,mesg)
fun hintln mesg = if (!runSilent) then () else TextIO.output (!outs,mesg ^ "\n")

end
