(* file: test_util.sml *)
(* description: utility functions for testing *)
(* author: Takahito Aoto *)

signature TEST_UTIL = 
sig 
    val test: string -> bool list -> unit
end

structure TestUtil : TEST_UTIL =
struct 

local
structure PU = PrintUtil
in

exception TestError

val moderate = false

fun test name checks = (PU.print (name ^ " test:");
			List.app (fn ck => if ck
					 then PU.print (".") 
					 else (PU.print ("FAIL"); if moderate then () else raise TestError)) checks;
			PU.print "\n")
end
end
